#!/usr/bin/perl

# Fucntion checks all appropriate rulesets for log line
sub checkruleset {
	$ind=$logs[$_[0]]{'logfile'};

	foreach $ruleset (@{$logfiles{$ind}}) {
		&check_rules($ruleset,$_[0]);
	}
}

# Check against individual rules, where appropriate
sub check_rules {
	(my $i);
	(my $rule);
	(my $format);
	
	for($i=0;$Ruleset{$_[0]}{'Rule'}[$i];$i++) {
		$rule=$Ruleset{$_[0]}{'Rule'}[$i];
		$format=$Ruleset{$_[0]}{'Format'}[$i];
		&check_ind_rule($rule,$_[1],$format,$_[0]);
	}
}

# Check an individual line
sub check_ind_rule {
	(my $rule);
	(my $subrule);
	(my $alltrue=1);
	(my $ind);
	(my $i);
	(my %tmphash);
	(my $rem_host="");
	(my $loc_user="");
	(my @retval=());
	(my @multiret=());
	(my $format);
	(my $ruleset);
	(my $ep);
	(my $lt);
	$rule=$_[0]; $ind=$_[1]; $format=$_[2]; $ruleset=$_[3];

	# Does the rule have a timeout?  Should it be used now?
	$ep=&to_epoch($logs[$ind]{'logline'});
	$lt=$ep-$last_time{$rule}{$ruleset};
	if($lt >= $Rule{$rule}{'Timeout'}){
		@retval=&{$Rule{$rule}{'Function'}}($ind);
	} 

	if($retval[0] || $retval[1]) {
		$last_time{$rule}{$ruleset}=$ep;
		if($Rule{$rule}{'Rules'}[0] ne "") {
			# We have sub rules ... need to check 'em
			foreach $subrule (@{$Rule{$rule}{'Rules'}}) {
				@multiret=&check_ind_rule($subrule,$ind,$format,$ruleset);
				if (!$retval[0] && !$retval[1]) {
					$alltrue=0;
				}
			}
			# and they all have to return true for the contacts to go.
			if ($alltrue) {
				$rem_host=$multiret[0];
				$loc_user=$multiret[1];
				&do_contacts($rule,$ind,$rem_host,$loc_user,$format,$ruleset);
				return @multiret;
			}
		} else {
			# Otherwise, just do the contacts.
			$rem_host=$retval[0];
			$loc_user=$retval[1];
			&do_contacts($rule,$ind,$rem_host,$loc_user,$format,$ruleset);
			return @retval;
		}
	}
	
}

# Perform the contacts.
sub do_contacts {
	(my $i);
	(my $ep);
	(my $newep);
	
	foreach $contact (@{$Rule{$_[0]}{'Contacts'}}) {
		# If it's a group contact, do all individual contacts
		if (exists $Group{$contact}) {
			foreach $con (@{$Group{$contact}}) {
				# If it's a beeper, make sure we're ok to beep (in refernce)
				# to beeper_timeout
				if($Contact{$con}{'Method'} eq 'beeper') {
					$ep=&to_epoch($logs[$_[1]]{'logline'});
					$newep=$last_beep{$con};
					if(($ep-$newep) > &ourtime_to_seconds($beeper_timeout)) {
						$last_beep{$con}=$ep;
						&do_contact($_[0],$_[1],$_[2],$_[3],$_[4],$con,$ruleset);
						# Have to sleep to avoid race condition
						sleep 1;
					}
				} else {
					# If it's not a beep contact - don't worry about it.
					&do_contact($_[0],$_[1],$_[2],$_[3],$_[4],$con,$ruleset);
				}
			}
		} else {
			# For a single (non-group) contact - just do it.  8)
			# Need to check beep timeout again
			if($Contact{$contact}{'Method'} eq 'beeper') {
				$ep=&to_epoch($logs[$_[1]]{'logline'});
				$newep=$last_beep{$contact};
				if(($ep-$newep) > &ourtime_to_seconds($beeper_timeout)) {
					$last_beep{$contact}=$ep;
					&do_contacts($_[0],$_[1],$_[2],$_[3],$_[4],$contact,$ruleset);
					# Have to sleep to avoid race condition
					sleep 1;
				}
			} else {
				&do_contact($_[0],$_[1],$_[2],$_[3],$_[4],$contact,$ruleset);
			}
		}
	}
}

sub do_contact {
	(my $contact="");
	(my $ind="");
	(my %infohash=());
	(my $format="");
	(my $tmp="");
	(my $realvar=0);
	(my $buffer=0);
	(my @buffer=());
	(my $realout="");
	(my $subject="");
	(my $ruleset="");
	(my $i);
	(my $j);

	$rule=$_[0];
	$ind=$_[1];
	$rem_host=$_[2];
	$loc_user=$_[3];
	$format=$_[4];
	$contact=$_[5];
	$ruleset=$_[6];

	%infohash=&head_parse($logs[$ind]{'logline'});

	if ($rem_host eq "") {
		$infohash{'source'}="(unknown)";
	} else {
		$infohash{'source'}=$rem_host;
	}

	if ($loc_user eq "") {
		$infohash{'user'}="(unknown)";
	} else {
		$infohash{'user'}=$loc_user;
	}

	$infohash{'rule'}=$rule;
	$infohash{'ruleset'}=$ruleset;

	# Do variable substitution for formatting
	@buffer=split(//,$Format{$format});
	for($i=1;$buffer[$i+1];$i++) {
		$tmp=""; $realvar=0;
		if($buffer[$i] eq "^") {
			for($i++;!$realvar;$i++) {
				$tmp.=$buffer[$i];
				if($_format{$tmp}) {
					$realvar=1;
				}
			}
			$realout.=$infohash{$tmp};
			$i--;
		} else {
			$realout.=$buffer[$i];
		}
	}

	if($Contact{$contact}{'Method'} eq "email") {
		$subject="Log Scanner Notice!";
		open (MAIL,"|$sendmail $Contact{$contact}{'Contact'}");
		print MAIL "Subject: $subject\n";
		print MAIL "\n\n$realout\n";
		close (MAIL);
	} elsif ($Contact{$contact}{'Method'} eq "log") {
		open (LOG,">>$Contact{$contact}{'Contact'}");
		print LOG "$realout\n";
		close(LOG);
	} elsif ($Contact{$contact}{'Method'} eq "audiofile") {
		system("cat $Contact{$contact}{'Contact'} >> $audiodev &");
	} elsif ($Contact{$contact}{'Method'} eq "beeper") {
		print STDERR "Calling pager.pl $Contact{$contact}{'Contact'} $realout\n";
		system("./pager.pl $Contact{$contact}{'Contact'} $realout &");
	}
}

1;
