# Global Declarations

# Valid contact methods
%_method=();
$_method{'email'}=1;
$_method{'log'}=1;
$_method{'audiofile'}=1;
$_method{'beeper'}=1; 
$_method{'externalprogram'}=0; # Not implemented yet
$_method{'phone'}=0;  # Not implemented yet

# Valid format variables
%_format=();
$_format{'month'}=1;
$_format{'day'}=1;
$_format{'time'}=1;
$_format{'host'}=1;
$_format{'process'}=1;
$_format{'pid'}=1;
$_format{'logline'}=1;
$_format{'source'}=1;
$_format{'user'}=1;
$_format{'rule'}=1;
$_format{'ruleset'}=1;

%Ruleset=();
@Ruleset_order=();
%Rule=();
@Rule_order=();
%Contact=();
@Contact_order=();
%Group=();
@Group_order=();
%Format=();
@Format_order=();
%last_beep=();
%last_time=();

sub load_conf_files {
	(my $file);
	%Ruleset=();
	@Ruleset_order=();
	%Rule=();
	@Rule_order=();
	%Contact=();
	@Contact_order=();
	%Group=();
	@Group_order=();
	%Format=();
	@Format_order=();
	%last_beep=();
	%last_time=();

	# Load the module files
	foreach $file (<$conf_dir/*$modules>) {
		require $file;
	}

	&_errorcheck_conf_files;
	&_load_conf_files;

}

sub _errorcheck_conf_files {
	# Check a couple 'o things
	if(!-d $conf_dir) {
		print STDERR "Directory \"$conf_dir\" does not exist.\n";
		print STDERR "Please edit the value for \$conf_dir (in files.cfg) and retry.\n";
		&quit_logscanner;
	} elsif(!-f $conf_dir."/".$conf_file) {
		print STDERR "Config file \"$conf_file\" does not exist.\n";
		print STDERR "Please edit the value for \$conf_file (in files.cfg) and retry.\n";
		&quit_logscanner;
	} elsif(!-r $conf_dir."/".$conf_file) {
		print STDERR "Config file \"$conf_file\" is not readable by you.\n";
		print STDERR "Please change permissions.\n";
		&quit_logscanner;
	} elsif(!-f $sendmail) {
		print STDERR "Could not find mail agent at \"$sendmail\".\n";
		print STDERR "Please change this is files.cfg.\n";
		&quit_logscanner;
	}
}

sub _load_conf_files {
	(my @buffer=());
	(my $buffer="");
	(my $linenumber=0);

	%Ruleset=();
	%Rule=();
	%Contact=();
	%Group=();
	%Format=();

	open(RULES,"$conf_dir/$conf_file") || die "Ack - couldn't open $conf_dir/$conf_file.\n";

	while(<RULES>) {
		$buffer=$_;
		chomp($buffer);
		$linenumber++;

		@buffer=split(/\s+/,$buffer);
		@buffer=split(//,$buffer[0]);

		unless ($buffer[0] eq "" || $buffer[0] eq "#") {

			if ($buffer[0] ne "c" &&
				$buffer[0] ne "g" &&
				$buffer[0] ne "o" &&
				$buffer[0] ne "r" &&
				$buffer[0] ne "f") { 
				print "Error in $conf_file on line $linenumber.\n";
				print "Unknown tag \"$buffer[0]\".\n";
				&quit_logscanner;
			} else { 
				$func="parse_".$buffer[0];
				&{$func}($buffer,$linenumber); 
			}
		}
	}

	close(RULES);
}

sub parse_c {
	(my $buffer="");
	(my @buffer=());
	(my $linenumber);
	(my $i);

	(my $name="");
	(my $method="");
	(my $contact="");

	$buffer=$_[0];
	$linenumber=$_[1];
	@buffer=split(//,$buffer);

	# Data retrieval
	for($i=0;$buffer[$i] && $buffer[$i] ne ':';$i++) {}

	for($i++;$buffer[$i] && $buffer[$i] ne ':';$i++) {
		$name.=$buffer[$i];
	}

	for($i++;$buffer[$i] && $buffer[$i] ne ':';$i++) {
		$method.=$buffer[$i];
	}
	$method=~tr/[A-Z]/[a-z]/;

	for($i++;$buffer[$i] && $buffer[$i] ne ':';$i++) {
		$contact.=$buffer[$i];
	}

	#Error Checking
	if(exists $Contact{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Duplicate contact.\n";
		&quit_logscanner;
	} elsif (exists $Group{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "You cannot use a same name for a contact and a group contact.\n";
		&quit_logscanner;
	} elsif (!$_method{$method}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Contact method \"$method\" is invalid.\n";
		&quit_logscanner;
	}

	# Going to leave validity checking for each method to other functions
	if ($method eq "email") {
		&check_valid_email($contact,$linenumber);
	} elsif ($method eq "audiofile") {
		&check_valid_audiofile($contact,$linenumber);
	} elsif ($method eq "log") {
		&check_valid_log($contact,$linenumber);
	} elsif ($method eq "beeper") {
		$last_beep{$name}=0;
	}

	$Contact{$name}{'Method'}=$method;
	$Contact{$name}{'Contact'}=$contact;
	$Contact_order[$#Contact_order+1]=$name;
}

sub check_valid_email {

}

sub check_valid_audiofile {
	if (!-f $_[0]) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Audiofile \"$_[0]\" does not exist or is not readable.\n";
		&quit_logscanner;
	} elsif (!-r $_[0]) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Audiofile \"$_[0]\" is not readable by you.\n";
		&quit_logscanner;
	}
}

sub check_valid_log {
	(my $buffer="");
	(my @buffer=());
	(my $testdir="");
	(my $i);
	(my $j);
	(my $linenumber=$_[1]);

	if (-f $_[0] && !-w $_[0]) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Log \"$_[0]\" exists, but is not writable by you.\n";
		&quit_logscanner;
	}

	# Check to see if the directory for the logfile even exists
	if (!-f $_[0]) {
		@buffer=split(//,$_[0]);
		for($i=$#buffer;$buffer[$i] ne '/' && $i>=0;$i--){}
		if($buffer[$i] eq '/') {
			for($j=0;$j<$i;$j++) {
				$testdir.=$buffer[$j];
			}
		} else {
			$testdir=".";
		}

		if(!-d $testdir) {
			print "Error in $conf_file on line $linenumber.\n";
			print "$testdir does not exist.\n";
		} elsif(!-w $testdir) {
			print "Error in $conf_file on line $linenumber.\n";
			print "$_[0] doesn't exist, and $testdir is not writable.\n";
		}
	}
}

sub parse_g {
	(my $buffer="");
	(my @buffer=());
	(my $linenumber);
	(my $i);

	(my $name="");
	(my $contact="");
	(my @contacts=());

	$buffer=$_[0];
	$linenumber=$_[1];
	@buffer=split(//,$buffer);

	#Data retrieval
	for($i=0;$buffer[$i] && $buffer[$i] ne ':';$i++) {}

	for($i++;$buffer[$i] && $buffer[$i] ne':';$i++) {
		$name.=$buffer[$i];
	}

	for($i++;$buffer[$i];$i++) {
		$contact.=$buffer[$i];
	}

	# Error Checking, etc

	@contacts=split(/,/,$contact);

	if(exists $Group{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Duplicate contact.\n";
		&quit_logscanner;
	} elsif (exists $Contact{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "You cannot use a same name for a contact and a group contact.\n";
		&quit_logscanner;
	}

	foreach $contact (@contacts) {
		if(!exists $Contact{$contact} && !exists $Group{$contact}) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Contact \"$contact\" does not exist.\n";
			&quit_logscanner;
		} else {
			$Group{$name}[$#{$Group{$name}}+1]=$contact;
		}
	}

	$Group_order[$#Group_order+1]=$name;
	
}

sub parse_o {
	(my @buffer=());
	(my $buffer="");
	(my $linenumber="");

	(my $format="");
	(my $name="");
	(my $realvar);
	(my $tmp="");
	(my $i);

	$buffer=$_[0];
	$linenumber=$_[1];
	@buffer=split(//,$buffer);

	# Get the data
	for($i=0;$buffer[$i] && $buffer[$i] ne ':';$i++) {}
	
	for($i++;$buffer[$i] && $buffer[$i] ne ':';$i++) {
		$name.=$buffer[$i];
	}

	for($i++;$buffer[$i];$i++) {
		$format.=$buffer[$i];
	}

	# Error checking
	if(exists $Format{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Duplicate format name \"$name\".\n";
		&quit_logscanner;
	}

	@buffer=split(//,$format);
	if ($buffer[0] ne '"' || $buffer[$#buffer] ne '"') {
		print "Error in $conf_file on line $linenumber.\n";
		print "The formatting MUST begin and end with a \".\n";
		&quit_logscanner;
	}
	# Check for valid format variables
	for($i=0;$buffer[$i];$i++) {
		$tmp=""; $realvar=0;
		if($buffer[$i] eq "^") {
		    for($i++;$buffer[$i]=~/[a-z]/i && !$realvar;$i++) {
				$tmp.=$buffer[$i];
				$realvar=1 if($_format{$tmp});
			}
			if(!$_format{$tmp}) {
				print "Error in $conf_file on line $linenumber.\n";
				print "Invalid variable name: \"$tmp\".\n";
				&quit_logscanner;
			} 
			$i-- if($buffer[$i] eq '^');
		}
	}
	
	$Format{$name}=$format;
	$Format_order[$#Format_order+1]=$name;
}

sub parse_r {
	(my $buffer="");
	(my @buffer=());
	(my $tmp="");
	(my @tmp=());
	(my $name="");
	(my $function="");
	(my $timeout="");
	(my $contact="");
	(my @contacts=());
	(my $rule="");
	(my @rules=());
	(my $i);

	$buffer=$_[0];
	$linenumber=$_[1];
	@buffer=split(/:/,$buffer);

	#Parse out the data
	$name=$buffer[1];

	$function=$buffer[2];

	$timeout=$buffer[3];
	$timeout=~tr/[A-Z]/[a-z]/;

	@contacts=split(/,/,$buffer[4]);
	@rules=split(/,/,$buffer[5]);

	# Error checking
	if(exists $Rule{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Duplicate Rule name \"$name\"\n";
		&quit_logscanner;
	}

	if(!defined &{$function}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "The function \"$function\" doesn't exist. \n";
		print "Please define in $modules file(s).\n";
		&quit_logscanner;
	}
	
	if(!($timeout=~/^[0-9]{1,}h[0-9]{1,}m[0-9]{1,}s$/)) {
		print "Error in $conf_file on line $linenumber.\n";
		print "I don't understand \"$timeout\".\n";
		print "Should be xhymzs, where x, y, and z are integers.\n";
		&quit_logscanner;
	} 

	foreach $contact (@contacts) {
		if(!exists $Contact{$contact} && !exists $Group{$contact}) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Contact \"$contact\" does not seem to exist.\n";
			&quit_logscanner;
		}
	}

	foreach $rule (@rules) {
		if($rule eq $name) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Rule \"$name\" is trying to call itself.\n";
			&quit_logscanner;
		} elsif(!exists $Rule{$rule}) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Rule \"$rule\" does not seem to exist.\n";
			&quit_logscanner;
		}
	}

	$Rule{$name}{'Function'}=$function;
	$Rule{$name}{'Timeout'}=&ourtime_to_seconds($timeout);
	@{$Rule{$name}{'Contacts'}}=@contacts;
	@{$Rule{$name}{'Rules'}}=@rules;
	$Rule_Order[$#Rule_order+1]=$name;

}

sub parse_f {
	(my $buffer="");
	(my @buffer=());
	(my $name="");
	(my $logfile);
	(my @logfiles=());
	(my $hasalpha=0);
	(my $rule);
	(my @rules=());
	(my $format);
	(my @formats=());
	(my $i=0);
	(my $c="");

	$buffer=$_[0];
	$linenumber=$_[1];
	@buffer=split(/:/,$buffer);

	# Get the data
	$name=$buffer[1];
	@logfiles=split(/,/,$buffer[2]);
	@rules=split(/,/,$buffer[3]);
	@formats=split(/,/,$buffer[4]);

	# Error checking...
	if (exists $Ruleset{$name}) {
		print "Error in $conf_file on line $linenumber.\n";
		print "Duplicate Ruleset name \"$name\".\n";
		&quit_logscanner;
	}

	if($logfiles[0] eq "") {
		print "Error in $conf_file on line $linenumber.\n";
		print "No logfiles found.\n";
	}
	
	for ($i=0;$logfiles[$i];$i++) {
		@buffer=split(//,$logfiles[$i]);
		if($buffer[0] ne '/') {
			$logfile="$def_log_dir/$logfiles[$i]";
			$logfiles[$i]=$logfile;
		} else {
			print "$logfiles[$i] is fine.\n";
		}
			
		if(!-f $logfiles[$i]) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Log file \"$logfile\" does not seem to exist.\n";
			&quit_logscanner;
		} elsif (!-r $logfiles[$i]) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Log file \"$logfile\" exists but you cannot read it.\n";
			&quit_logscanner;
		}
	}

	if($#rules ne $#formats) {
		print "Error in $conf_file on line $linenumber.\n";
		print "There are more ";
		if($#rules > $#formats) {
			print "rules than formats";
		} else {
			print "formats than rules";
		}
		print ". There should be an equal number.\n";
		&quit_logscanner;
	}

	for ($i=0;$rules[$i];$i++){ 
		if (!exists $Rule{$rules[$i]}) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Rule \"$rule[$i]\" does not seem to exist.\n";
			&quit_logscanner;
		} 
	}

	if($rules[0] eq "") {
		print "Error in $conf_file on line $linenumber.\n";
		print "No rules found.\n";
	}

	foreach $format (@formats) {
		if(!exists $Format{$format}) {
			print "Error in $conf_file on line $linenumber.\n";
			print "Format \"$format\" does not seem to exist.\n";
		}
	}


	@{$Ruleset{$name}{'LogFile'}}=@logfiles;
	@{$Ruleset{$name}{'Rule'}}=@rules;
	@{$Ruleset{$name}{'Format'}}=@formats;
	$Ruleset_order[$#Ruleset_order+1]=$name;
}


1;
